#include "piletypes.h"
#include <malloc.h>
#include <assert.h>

typedef struct STACKELEM {
    SYMType _type;
    struct STACKELEM *next;
}StackElem;

StackElem *StackHead=NULL;

void stypeStack(SYMType type)
{
	StackElem *newElem = malloc(sizeof(StackElem));
	newElem->_type=type;
	newElem->next=StackHead;
	
	StackHead=newElem;
}

void stypeUnstack()
{
	assert(StackHead != NULL);
	
	StackElem *tmp=StackHead;
	StackHead = StackHead->next;
	
	free(tmp);
}

SYMType stypeGet()
{
	assert(StackHead != NULL);
	
	return StackHead->_type;
}

int stypeIsEmpty()
{
		if(StackHead == NULL)
			return 1;
		else
			return 0;
}

SYMType stypeGetSecond()
{
  int tmp; int retour;
  tmp=stypeGet();
  stypeUnstack();
  retour=stypeGet();
  stypeStack(tmp);
  return retour;
}
